// device.h
//    2007.6 Y.Senta

#ifndef _DEVICE_H_
#define _DEVICE_H_

#include "configstr.h"

#define DATAMASK 0xff
#define CONFSIZE 0x0f

enum PWTYPE{
  VDD_BEFORE_VPP,
  VPP_BEFORE_VDD
};

enum PGTYPE{
  INTERNAL08,
  INTERNAL18,
  EXTERNAL08,
  EXTERNAL18
};

enum ESTYPE{
  BULKERASE_F509,
  BULKERASE_F675,
  BULKERASE_F683,
  BULKERASE_F84,
  BULKERASE_F648A,
  CHIPERASE_F88,
  CHIPERASE_F77
};

class device{
  char *m_pName;
  
  int  m_nIDword;
  int  m_nIDAddr;
  PWTYPE m_ePowerUp;
  int  m_nPMMask;
  int  m_nPMSize;
  int  m_nEEMemSize;
  int  m_nConfAddr1;
  int  m_nConfAddr2;
  int  m_nConfMask1;
  int  m_nConfMask2;
  int  m_nCalibAddr1;
  int  m_nCalibAddr2;
  int  m_nCalibMask1;
  int  m_nCalibMask2;
  PGTYPE m_eProgType;
  PGTYPE m_eProgTypeC;
  int  m_nProgWait;
  int  m_nProgWaitD;
  int  m_nProgWaitC;
  int  m_nProgLatch;
  ESTYPE m_eEraseType;
  int  m_nEraseWait;
  int  m_nPaMask;
  bool m_bLVP;
 public:
  device(const char *);
  ~device();
  
  device *m_pNext;
  bool Load(FILE *);

  char *GetName(){
	return m_pName;
  }
  int GetProgSize(){
    return m_nPMSize;
  }
  int GetDataSize(){
    return m_nEEMemSize;
  }
  int GetConfSize(){
    return CONFSIZE;
  }
  int GetCalibAddr1(){
	return m_nCalibAddr1;
  }
  int GetCalibAddr2(){
	return m_nCalibAddr2;
  }
  int GetCalibMask1(){
	return m_nCalibMask1;
  }
  int GetCalibMask2(){
	return m_nCalibMask2;
  }
  int GetEraseWait(){
	return m_nEraseWait;
  }
  int GetProgWait(){
	return m_nProgWait;
  }
  int GetProgWaitC(){
	return m_nProgWaitC;
  }
  int GetProgWaitD(){
	return m_nProgWaitD;
  }
  int GetProgLatch(){
	return m_nProgLatch;
  }
  PWTYPE GetPowerupType(){
	return m_ePowerUp;
  }
  ESTYPE GetEraseType(){
	return m_eEraseType;
  }
  int GetDeviceID(){
	return m_nIDword;
  }
  int GetPMMask(){
    return m_nPMMask;
  }
  int GetConfMask1(){
    return m_nConfMask1;
  }
  int GetConfMask2(){
    return m_nConfMask2;
  }
  bool isSupportLVP(){
	return m_bLVP;
  }
  PGTYPE GetProgType(){
	return m_eProgType;
  }
  int GetConfAddr1(){
	return m_nConfAddr1;
  }
  int GetConfAddr2(){
	return m_nConfAddr2;
  }
};

#endif
