// piccommand.h
//    2007.6 Y.Senta

#ifndef _PICCOMMAND_H_
#define _PICCOMMAND_H_

#include "picmemory.h"

enum WAITTYPE{
  WAIT_PROG,
  WAIT_DATA,
  WAIT_CONF,
};

class device;
class serialport;

class piccommand{
 public:
  bool m_bCheck;
  bool m_bErase;
  bool m_bWrite;
  bool m_bVerify;
  bool m_bRead;
  bool m_bChgBps;
  bool m_bAdvance;
  
  bool m_bLVP;
  bool m_bQuite;
  
  device *m_pDevice;
  serialport *m_pSerial;
  
  int m_nNewBps;
  
  FILE *m_pFHexI;
  FILE *m_pFHexO;
  
  bool Command();
  
 private:
  picmemory m_Mem;
  
  bool m_bExpWriter;
  
  bool CheckWriter();
  bool ChangeSpeed();
  bool ChipErase();
  bool ReadBuffer();
  bool WriteBuffer();
  bool VerifyBuffer();
  
  bool BackupCalib();
  bool RestoreCalib();
  bool PowerON();
  bool PowerDown();
  bool PowerDownTryAgain();
  
  bool InternalTime(int, int);
  bool ExternalTime(int, int, int);
  bool Increment();
  bool Increment(int);
  bool Setup(int);
  bool LoadConfig(int);
  bool DeviceCheck();
  bool ReadProgMemory(int *);
  bool ReadDataMemory(int *);
  bool LoadProgMemory(int);
  
  bool BulkeraseF509();
  bool BulkeraseF675();
  bool BulkeraseF683();
  bool BulkeraseF84();
  bool BulkeraseF648A();
  bool ChiperaseF88();
  bool ChiperaseF77();
  bool SendBeginProg(WAITTYPE);

  bool LoadProgMemory8(int *);
};

#endif
