// picw509env.h
//    2007.6 Y.Senta

#ifndef _PICW509ENV_H_
#define _PICW509ENV_H_

class device;

class picw509cmd{
 public:
  bool m_bCheck;
  bool m_bErase;
  bool m_bWrite;
  bool m_bVerify;
  bool m_bRead;
  
  bool m_bLVP;
  bool m_bQuite;

  bool m_bAdvance;
  
  char *m_pBPS;
  char *m_pDeviceName;
  char *m_pChipName;
  char *m_pNewBPS;
  char *m_pInputHEXPath;
  char *m_pOutputHEXPath;
  
  picw509cmd(){
    m_bCheck=false;
    m_bErase=false;
    m_bWrite=false;
    m_bVerify=false;
    m_bRead=false;
	
    m_bLVP=false;
    m_bQuite=false;

	m_bAdvance=true;
	
    m_pDeviceName=NULL;
    m_pBPS=NULL;
    m_pChipName=NULL;
    m_pNewBPS=NULL;
    m_pInputHEXPath=NULL;
    m_pOutputHEXPath=NULL;
  };
  
  ~picw509cmd(){
    if (m_pDeviceName)
      delete [] m_pDeviceName;
    if (m_pBPS)
      delete [] m_pBPS;
    if (m_pChipName)
      delete [] m_pChipName;
    if (m_pNewBPS)
      delete [] m_pNewBPS;
    if (m_pInputHEXPath)
      delete [] m_pInputHEXPath;
    if (m_pOutputHEXPath)
      delete [] m_pOutputHEXPath;
  }
  void DBDump();
  bool ChipAccessCmd();
  bool isCommand();
};

class picw509env{
 public:
  bool Init(const char *);
  bool DoCmd(picw509cmd *);
  
  picw509env();
  ~picw509env();
  
  void DumpDevice();
  
 private:
  device *m_pDeviceList;
  
  bool LoadDeviceList(const char *);
  device *SearchChip(const char *);
};
#endif
